Gecode::Int::Branch::ViewValuesBrancher< n, min, Filter, Print > Class Template Reference

Brancher by view and values selection More...

`#include <branch.hh>`

## Public Member Functions

virtual const Choice * | choice (Space &home)
| Return choice.
virtual const Choice * | choice (const Space &home, Archive &e)
| Return choice.
virtual ExecStatus | commit (Space &home, const Choice &c, unsigned int a)
| Perform commit for choice c and alternative a.
virtual NGL * | ngl (Space &home, const Choice &c, unsigned int a) const
| Create no-good literal for choice c and alternative a.
virtual void | print (const Space &home, const Choice &c, unsigned int a, std::ostream &o) const
| Print branch for choice c and alternative a.
virtual Actor * | copy (Space &home)
| Perform cloning.
virtual size_t | dispose (Space &home)
| Delete brancher and return its size.
Public Member Functions inherited from Gecode::ViewBrancher< IntView, Filter, n >
virtual bool | status (const Space &home) const
| Check status of brancher, return true if alternatives left.
unsigned int | id (void) const
| Return brancher id.
BrancherGroup | group (void) const
| Return group brancher belongs to.
void | group (BrancherGroup g)
| Add brancher to group g.
virtual | ~Actor (void)
| To avoid warnings.

## Static Public Member Functions

static void | post (Home home, ViewArray< IntView > &x, ViewSel< IntView > *vs[n], IntBranchFilter bf, IntVarValPrint vvp)
| Post function for creation.
static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.

## Protected Member Functions

| ViewValuesBrancher (Space &home, ViewValuesBrancher &b)
| Constructor for cloning b.
| ViewValuesBrancher (Home home, ViewArray< IntView > &x, ViewSel< IntView > *vs[n], IntBranchFilter bf, IntVarValPrint vvp)
| Constructor for creation.
Protected Member Functions inherited from Gecode::ViewBrancher< IntView, Filter, n >
Pos | pos (Space &home)
| Return position information.
IntView | view (const Pos &p) const
| Return view according to position information p.
| ViewBrancher (Space &home, ViewBrancher< IntView, Filter, n > &b)
| Constructor for cloning b.
Protected Member Functions inherited from Gecode::Brancher
| Brancher (Home home)
| Constructor for creation.
| Brancher (Space &home, Brancher &b)
| Constructor for cloning b.

## Protected Attributes

Print | p
| Print function.
Protected Attributes inherited from Gecode::ViewBrancher< IntView, Filter, n >
ViewArray< IntView > | x
| Views to branch on.
int | start
| Unassigned views start at x[start].
ViewSel< IntView > * | vs [n]
| View selection objects.
Filter | f
| Filter function.

## Additional Inherited Members

Protected Types inherited from Gecode::ViewBrancher< IntView, Filter, n >
typedef IntView::VarType | Var
| The corresponding variable.

## Detailed Description

template<int n, bool min, class Filter, class Print>
class Gecode::Int::Branch::ViewValuesBrancher< n, min, Filter, Print >

Brancher by view and values selection

Definition at line 626 of file branch.hh.

## Constructor & Destructor Documentation

## ViewValuesBrancher() [1/2]

template<int n, bool min, class Filter, class Print>

Gecode::Int::Branch::ViewValuesBrancher< n, min, Filter, Print >::ViewValuesBrancher | ( | Space & | home,
|  | ViewValuesBrancher< n, min, Filter, Print > & | b )

inline protected

Constructor for cloning b.

Definition at line 111 of file view-values.hpp.

## ViewValuesBrancher() [2/2]

template<int n, bool min, class Filter, class Print>

Gecode::Int::Branch::ViewValuesBrancher< n, min, Filter, Print >::ViewValuesBrancher | ( | Home | home,
|  | ViewArray< IntView > & | x,
|  | ViewSel< IntView > * | vs[n],
|  | IntBranchFilter | bf,
|  | IntVarValPrint | vvp )

inline protected

Constructor for creation.

Definition at line 89 of file view-values.hpp.

## Member Function Documentation

## choice() [1/2]

template<int n, bool min, class Filter, class Print>

const Choice * Gecode::Int::Branch::ViewValuesBrancher< n, min, Filter, Print >::choice | ( | Space & | home | ) |

virtual

Return choice.

Implements Gecode::Brancher.

Definition at line 124 of file view-values.hpp.

## choice() [2/2]

template<int n, bool min, class Filter, class Print>

const Choice * Gecode::Int::Branch::ViewValuesBrancher< n, min, Filter, Print >::choice | ( | const Space & | home,
|  | Archive & | e )

virtual

Return choice.

Implements Gecode::Brancher.

Definition at line 132 of file view-values.hpp.

## commit()

template<int n, bool min, class Filter, class Print>

ExecStatus Gecode::Int::Branch::ViewValuesBrancher< n, min, Filter, Print >::commit | ( | Space & | home,
|  | const Choice & | c,
|  | unsigned int | a )

virtual

Perform commit for choice c and alternative a.

Implements Gecode::Brancher.

Definition at line 143 of file view-values.hpp.

## ngl()

template<int n, bool min, class Filter, class Print>

NGL * Gecode::Int::Branch::ViewValuesBrancher< n, min, Filter, Print >::ngl | ( | Space & | home,
|  | const Choice & | c,
|  | unsigned int | a ) const

virtual

Create no-good literal for choice c and alternative a.

Reimplemented from Gecode::Brancher.

Definition at line 154 of file view-values.hpp.

## print()

template<int n, bool min, class Filter, class Print>

void Gecode::Int::Branch::ViewValuesBrancher< n, min, Filter, Print >::print | ( | const Space & | home,
|  | const Choice & | c,
|  | unsigned int | a,
|  | std::ostream & | o ) const

virtual

Print branch for choice c and alternative a.

Prints an explanation of the alternative a of choice c on the stream o.

Reimplemented from Gecode::Brancher.

Definition at line 165 of file view-values.hpp.

## copy()

template<int n, bool min, class Filter, class Print>

Actor * Gecode::Int::Branch::ViewValuesBrancher< n, min, Filter, Print >::copy | ( | Space & | home | ) |

virtual

Perform cloning.

Implements Gecode::Actor.

Definition at line 117 of file view-values.hpp.

## post()

template<int n, bool min, class Filter, class Print>

void Gecode::Int::Branch::ViewValuesBrancher< n, min, Filter, Print >::post | ( | Home | home,
|  | ViewArray< IntView > & | x,
|  | ViewSel< IntView > * | vs[n],
|  | IntBranchFilter | bf,
|  | IntVarValPrint | vvp )

inline static

Post function for creation.

Definition at line 101 of file view-values.hpp.

## dispose()

template<int n, bool min, class Filter, class Print>

size_t Gecode::Int::Branch::ViewValuesBrancher< n, min, Filter, Print >::dispose | ( | Space & | home | ) |

inline virtual

Delete brancher and return its size.

Reimplemented from Gecode::ViewBrancher< IntView, Filter, n >.

Definition at line 182 of file view-values.hpp.

## Member Data Documentation

## p

template<int n, bool min, class Filter, class Print>

Print Gecode::Int::Branch::ViewValuesBrancher< n, min, Filter, Print >::p

protected

Print function.

Definition at line 631 of file branch.hh.

The documentation for this class was generated from the following files:

- gecode/int/branch.hh
- gecode/int/branch/view-values.hpp